Last Comment Bug 685059 - Remove empty placeholder icon when a page has no favicon
: Remove empty placeholder icon when a page has no favicon
Status: RESOLVED FIXED
[Australis:M3]
:
Product: Firefox
Classification: Client Software
Component: Tabbed Browser (show other bugs)
: Trunk
: All All
-- enhancement with 21 votes (vote)
: Firefox 28
Assigned To: Mike Conley (:mconley)
:
: Dão Gottwald [:dao]
Mentors:
: 690195 847444 (view as bug list)
Depends on: 865776
Blocks: australis-tabs 648668 702730 865728
  Show dependency treegraph
 
Reported: 2011-09-06 20:43 PDT by Dan Jacobson
Modified: 2016-01-07 07:27 PST (History)
34 users (show)
mconley: needinfo? (omaryak)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
screenshot of default favicons on bookmarks toolbar (41.28 KB, image/png)
2011-10-03 14:12 PDT, Lukas Blakk [:lsblakk] use ?needinfo
no flags Details
Patch v1 (3.32 KB, patch)
2013-04-16 13:09 PDT, Mike Conley (:mconley)
no flags Details | Diff | Splinter Review
Patch v1.1 (3.54 KB, patch)
2013-04-17 11:45 PDT, Mike Conley (:mconley)
dao+bmo: review-
shorlander: ui‑review+
Details | Diff | Splinter Review
Patch v1 on OSX (65.82 KB, image/png)
2013-04-17 12:02 PDT, Mike Conley (:mconley)
no flags Details
Patch v1 on Ubuntu Linux (35.68 KB, image/png)
2013-04-17 13:02 PDT, Mike Conley (:mconley)
no flags Details
Patch v1 on Windows 7 (39.75 KB, image/png)
2013-04-17 13:05 PDT, Mike Conley (:mconley)
no flags Details
Patch v1 on Windows XP (14.32 KB, image/png)
2013-04-17 13:08 PDT, Mike Conley (:mconley)
no flags Details
Patch v1.2 (ui-r+'d by shorlander) (3.05 KB, patch)
2013-04-24 11:04 PDT, Mike Conley (:mconley)
dao+bmo: review-
Details | Diff | Splinter Review
Patch v1.3 (ui-r+'d by shorlander) (3.15 KB, patch)
2013-04-24 11:17 PDT, Mike Conley (:mconley)
dao+bmo: review+
Details | Diff | Splinter Review

Description User image Dan Jacobson 2011-09-06 20:43:21 PDT
User Agent: Mozilla/5.0 (X11; Linux i686; rv:8.0a2) Gecko/20110905 Firefox/8.0a2 Iceweasel/8.0a2
Build ID: 20110905042011

Steps to reproduce:

Gentlemen, observe each tab carries a empty dashed rectangle to its left.
These rectangles are in the same spot spinning red circles are in when the page is loading.
But after it is loaded, these useless rectangles just sit there, wasting precious tag title space.
Kindly revert this no-brainer decoration.
Comment 1 User image Cork 2011-09-06 21:17:41 PDT
That rectangle is the replacement of the olde empty page acting as a placeholder for the pages favicon. So reverting it would mean switching to the old icon.
Comment 2 User image Siddhartha Dugar [:sdrocking] 2011-09-07 03:05:22 PDT
(In reply to Cork from comment #1)
> That rectangle is the replacement of the olde empty page acting as a
> placeholder for the pages favicon. So reverting it would mean switching to
> the old icon.

This bug aims to remove the generic icon, instead of reverting it to anything. Use this style until then - http://userstyles.org/styles/49060/ff3-hide-blank-tab-favicon
Comment 3 User image Dan Jacobson 2011-09-07 08:02:01 PDT
Yes, no need for 'reserved parking spaces' wasting space.
Comment 4 User image :Margaret Leibovic 2011-09-07 11:17:54 PDT
If the icon is hidden after the page finishes loading, the title will need to suddenly shift over to occupy that empty space, which seems like it would be pretty jarring. Even if we add a transition for that, I think it would draw too much attention to the tab, when the user really wants to be looking at the page that just finished loading.
Comment 5 User image Dão Gottwald [:dao] 2011-09-07 11:24:49 PDT
(In reply to Margaret Leibovic [:margaret] from comment #4)
> If the icon is hidden after the page finishes loading, the title will need
> to suddenly shift over to occupy that empty space, which seems like it would
> be pretty jarring. Even if we add a transition for that, I think it would
> draw too much attention to the tab, when the user really wants to be looking
> at the page that just finished loading.

This is a concern, but I'm not sure how jarring it really would be. I suspect it would be more jarring with a transition.

On the positive side, this would make tabs without icons more recognizable by showing more of their titles.
Comment 6 User image Dan Jacobson 2011-09-07 16:35:18 PDT
(In reply to Margaret Leibovic [:margaret] from comment #4)
Hahahaha "jarring". Don't worry, nobody will notice one more jar amongst the million, at least on my system.
Comment 7 User image Frank Yan (:fryn) 2011-09-28 21:40:38 PDT
*** Bug 690195 has been marked as a duplicate of this bug. ***
Comment 8 User image Stephen Horlander [:shorlander] 2011-09-28 22:05:37 PDT
The popping when the loading icon is finished and the broken tab consistency feels kind of gross but that might just be my "OMG Change!" reflex kicking in.

It does feel cleaner without all the placeholder icons though.
Comment 9 User image Lukas Blakk [:lsblakk] use ?needinfo 2011-10-03 14:12:42 PDT
Created attachment 564324 [details]
screenshot of default favicons on bookmarks toolbar

related: the default favicon takes up unnecessary space in my bookmark toolbar too, it would be great to nothing there if there's no favicon (or a config setting to turn them off in the toolbar?)
Comment 10 User image :Margaret Leibovic 2011-10-03 16:56:11 PDT
(In reply to Lukas Blakk [:lsblakk] from comment #9)
> Created attachment 564324 [details]
> screenshot of default favicons on bookmarks toolbar
> 
> related: the default favicon takes up unnecessary space in my bookmark
> toolbar too, it would be great to nothing there if there's no favicon (or a
> config setting to turn them off in the toolbar?)

This would require a separate fix -- would you mind filing a new bug in Bookmarks & History?
Comment 11 User image Lukas Blakk [:lsblakk] use ?needinfo 2011-10-03 17:08:37 PDT
> This would require a separate fix -- would you mind filing a new bug in
> Bookmarks & History?

done. bug 691594
Comment 12 User image adamcox82 2011-11-10 03:29:49 PST
This should be looked at urgently for the next release.

The decision made in https://bugzilla.mozilla.org/show_bug.cgi?id=648668 was a very misguided interface mistake, as evidenced by the hundreds of users complaining about this:
https://support.mozilla.com/en-US/search?w=2&a=1&created=0&created_date=&updated=0&updated_date=&sortby=0&asked_by=&answered_by=&num_voted=0&num_votes=&q_tags=&q=favicon+8

The new "dotted rounded square" is an unsuitable replacement for the "blank document" icon, because it incorrectly implies a missing or broken element where there is none (since favicons are entirely optional). At the very least, this should have been implemented as a user-selectable interface option.

Visual change for its own sake is illogical. Remember:
http://www.codinghorror.com/blog/2005/08/the-user-interface-is-the-application.html
Comment 13 User image Peter E. Humphries 2011-11-10 07:38:43 PST
Is this a different bug than the dotted square replacing favicons that do, in fact, exist, and were working in FF7 but are now "missing" in FF8?

It appears that this is a more complex bug than simply bad / unexpected UI design.  Take this page, for instance: in the title bar, the Bugzilla favicon appears ( https://bugzilla.mozilla.org/extensions/BMO/web/images/favicon.ico ), but on the tab is the dotted box.  Even Google Canada's favicon is missing; although it is not coded in the HTML, it is sitting in the expected spot ( http://www.google.com/favicon.ico ).
Comment 14 User image Peter E. Humphries 2011-11-10 08:10:14 PST
I have discovered that the favicon will appear in the address bar (for sites that have one, whether coded with rel="icon" or in the default root location) after clicking on the "blank" icon beside the address.  (Moving the tab may have the same effect; I am sure that it happened, once, but I have not been able to reproduce it!)

The favicon does not persist, however.  Once the page is reloaded or after clicking a link to another page on the same site, the behaviour repeats ("blank" favicon until clicked).

I have not discovered any way to force the favicon to display on the tab.

I have tested pages that do not have the rel="icon" instruction but do have a default favicon.ico in the site's root, pages that have both a (different) default favicon and a rel="icon" direction, pages that change icons as the site is navigated (different favicons for different pages) and a variety of capitalization ("Icon" "ICON" &c) in the rel="icon" (or rel="shortcut icon") instruction.

Perhaps this is a bug that is deeper than just the change in the picture used for sites without favicons.
Comment 15 User image R. Glass 2011-11-10 08:17:53 PST
Previous versions were fine, but this week's update to v 8.0 effectively removed the favicons from my bookmarks as well as the location bar. Being a visual learner this is a real disappointment to me. I know the favicons are on the servers because some of them are from my own websites.
Comment 16 User image Peter E. Humphries 2011-11-10 08:46:39 PST
The favicon also does not appear in the Page Info / Media preview until you click on another picture and then click back on the favicon entry.

This has no effect on the address bar or tab display, and the favicon sometimes persists and sometimes does not when you exit the Page Info window and open it, again.  I have not figured out if there is any pattern to this latter behaviour.
Comment 17 User image :Margaret Leibovic 2011-11-10 09:42:13 PST
This bug is only about removing the new placeholder icon when a page does not have a favicon.

Valid favicons disappearing is a separate (and bad) bug that somehow managed to get through Aurora and Beta without being filed.

R. and Peter, it sounds like you guys are experiencing bug 701297. If so, could you comment in there with steps to reproduce.
Comment 18 User image Peter E. Humphries 2011-11-10 10:24:12 PST
Thanks, Margaret.  I will post these over in that bug; I did not find it when I was looking, earlier.
Comment 19 User image Jennifer Morrow [:Boriss] (UX) 2012-01-27 14:42:13 PST
You're entirely right that the current dotted-border favicon isn't working very well.  It's a bit too small of field to really merit a marching-ant-style marquee.  However, I don't think just showing nothing is the way to handle this problem, but rather improving the placeholder icon.  After all, showing nothing could just suggest that the favicon has not loaded yet, rather than the page has none.  You'd end up with a tab bar which had some favicons and some empty spaces, making it visually jarring and seemingly taking longer to load ("how long must I wait for this favicon to appear?".  I'm going to close this bug, since we don't want some tabs to simply have no favicon, but improving that icon should certainly be another bug.
Comment 20 User image Forest 2012-01-27 15:08:20 PST
For the record, I disagree. The only use I have for favicons is to identify a particular web site, or distinguish it from its neighbors in a list, faster than I can read its title. A generic icon would not accomplish this, serving instead only to add clutter and (in the case of horizontal lists like to bookmark bar) to waste space. For sites with no favicon, and for other kinds of bookmark (e.g. bookmarklets), showing no icon is *exactly* what I want.

Also, I would certainly not sit around wondering how long I must wait for a favicon to appear. It's a favicon, not my email. I don't care if it takes a while to load, and I'm perfectly aware that not all sites have them.

If you're really bent on wasting space with icons that have no purpose, I hope you'll at least make it a configurable option.
Comment 21 User image Dão Gottwald [:dao] 2012-01-28 00:46:23 PST
Boriss, according to your explanation, this is a typical WONTFIX rather than WORKSFORME. See <https://bugzilla.mozilla.org/page.cgi?id=fields.html#status>.
Comment 22 User image Dick Boogaers 2012-01-28 06:51:51 PST
@dao: 
However, what you could do, is make the icon more looking like: "hé this icon is missing" in stead of "what kind of bug does firefox have now, with these dotted boxes".

I installed the Silvermel 1.4.4 (http://www.silvermel.net/) theme. It solves this problem by showing the icon of a bookmark for these cases. Looks beautiful and does the job well of revealing that the site doesn't have an icon of its own.

So, WONTFIX should not mean: "we'll never look at this again", in stead it should mean: "we'll never look at this again, unless someone comes along with a very good idea".
Comment 23 User image Gergely 2012-01-29 01:39:30 PST
(In reply to Forest from comment #20)

> If you're really bent on wasting space with icons that have no purpose, I
> hope you'll at least make it a configurable option.

Forest, for the record, I totally agree with you.
Comment 24 User image Stephen Horlander [:shorlander] 2012-02-28 14:26:56 PST
Discussed with Boriss and we want this for the current Australis theme work.
Comment 25 User image Guillaume C. [:ge3k0s] 2012-03-01 12:28:11 PST
The default blank favicon should all the same be updated for bookmarks (Chrome do a pretty good job concerning this as in many other UI area).
Comment 26 User image Mike Conley (:mconley) 2013-03-04 09:14:49 PST
*** Bug 847444 has been marked as a duplicate of this bug. ***
Comment 27 User image Guillaume C. [:ge3k0s] 2013-03-04 10:16:42 PST
It's not completely related but all Firefox in-content pages should have a favicon (maybe before landing this). I'm especially thinking about the new tab page ( http://people.mozilla.com/~shorlander/files/australis-design-specs/images/Australis-i01-DesignSpec-InContentUI-Dashboard-%28NewTab%29.jpg ).
Comment 28 User image Mike Conley (:mconley) 2013-04-16 13:09:01 PDT
Created attachment 738151 [details] [diff] [review]
Patch v1
Comment 29 User image Mike Conley (:mconley) 2013-04-16 13:09:29 PDT
Need to test this on Linux and OSX first, and then I'll request review.
Comment 30 User image Mike Conley (:mconley) 2013-04-17 11:45:22 PDT
Created attachment 738650 [details] [diff] [review]
Patch v1.1

As per UX request, the tab labels have been re-centered on OSX.

Testing Linux next, and then I'll huck up some screenshots.
Comment 31 User image Mike Conley (:mconley) 2013-04-17 12:02:41 PDT
Created attachment 738661 [details]
Patch v1 on OSX
Comment 32 User image Mike Conley (:mconley) 2013-04-17 13:02:42 PDT
Created attachment 738697 [details]
Patch v1 on Ubuntu Linux
Comment 33 User image Mike Conley (:mconley) 2013-04-17 13:05:42 PDT
Created attachment 738700 [details]
Patch v1 on Windows 7
Comment 34 User image Mike Conley (:mconley) 2013-04-17 13:08:20 PDT
Created attachment 738701 [details]
Patch v1 on Windows XP
Comment 35 User image Forest 2013-04-17 13:23:57 PDT
Can you add screen shots showing how sites without favicons look in the Bookmark Toolbar?  I'd love to be rid of those stupid placeholder icons that appear next to my bookmarklets.
Comment 36 User image Mike Conley (:mconley) 2013-04-17 13:32:19 PDT
(In reply to Forest from comment #35)
> Can you add screen shots showing how sites without favicons look in the
> Bookmark Toolbar?  I'd love to be rid of those stupid placeholder icons that
> appear next to my bookmarklets.

At this point, I'm only concerned about the placeholder favicons in the tabs, as this is a potential blocker for the Australis theme changes.
Comment 37 User image Guillaume C. [:ge3k0s] 2013-04-18 01:56:44 PDT
(In reply to Forest from comment #35)
> Can you add screen shots showing how sites without favicons look in the
> Bookmark Toolbar?  I'd love to be rid of those stupid placeholder icons that
> appear next to my bookmarklets.

See bug 747620.
Comment 38 User image Stephen Horlander [:shorlander] 2013-04-23 14:02:55 PDT
Comment on attachment 738650 [details] [diff] [review]
Patch v1.1

Review of attachment 738650 [details] [diff] [review]:
-----------------------------------------------------------------

Looks good!
Comment 39 User image Mike Conley (:mconley) 2013-04-23 14:03:57 PDT
Comment on attachment 738650 [details] [diff] [review]
Patch v1.1

If you're overloaded Matt, let me know and I'll redirect the review request.
Comment 40 User image Dão Gottwald [:dao] 2013-04-23 19:10:34 PDT
Comment on attachment 738650 [details] [diff] [review]
Patch v1.1

>--- a/browser/base/content/browser.css	Fri Apr 12 18:33:01 2013 -0400
>+++ b/browser/base/content/browser.css	Wed Apr 17 14:18:35 2013 -0400
>@@ -51,16 +51,17 @@ tabbrowser {
>   max-width: 0.1px;
>   min-width: 0.1px;
>   opacity: 0 !important;
>   transition: min-width 200ms ease-out,
>               max-width 250ms ease-out,
>               opacity 50ms ease-out 180ms /* hide the tab for the last 20ms of the max-width transition */;
> }
> 
>+.tab-icon-image:not([src]):not([pinned]),
> .tab-throbber:not([fadein]):not([pinned]),
> .tab-label:not([fadein]):not([pinned]),
> .tab-icon-image:not([fadein]):not([pinned]),
> .tab-close-button:not([fadein]):not([pinned]) {
>   display: none;
> }

These rules are about tab animations, which your selector has nothing to do with. You should add it here at line 44: http://hg.mozilla.org/mozilla-central/annotate/d8202613aaea/browser/base/content/tabbrowser.css#l44

>--- a/browser/themes/osx/browser.css	Fri Apr 12 18:33:01 2013 -0400
>+++ b/browser/themes/osx/browser.css	Wed Apr 17 14:18:35 2013 -0400

>+.tab-text {
>+  margin: 0;
>+}

.tab-label

>--- a/browser/themes/shared/tabs.inc.css	Fri Apr 12 18:33:01 2013 -0400
>+++ b/browser/themes/shared/tabs.inc.css	Wed Apr 17 14:18:35 2013 -0400

>+.tab-throbber,
>+.tab-icon-image {
>+  width: 16px;
>+  height: 16px;
>+  list-style-image: url("chrome://mozapps/skin/places/defaultFavicon.png");
>+}

defaultFavicon.png doesn't make sense for .tab-throbber. This is particularly confusing because you put this in tabs.inc.css while leaving the .tab-throbber specific rules in the individual browser.css files.
Comment 41 User image Mike Conley (:mconley) 2013-04-24 11:04:44 PDT
Created attachment 741433 [details] [diff] [review]
Patch v1.2 (ui-r+'d by shorlander)

(In reply to Dão Gottwald [:dao] from comment #40)
> Comment on attachment 738650 [details] [diff] [review]
> Patch v1.1

Hey Dão, thanks for the drive-by!

> 
> >--- a/browser/base/content/browser.css	Fri Apr 12 18:33:01 2013 -0400
> >+++ b/browser/base/content/browser.css	Wed Apr 17 14:18:35 2013 -0400
> >@@ -51,16 +51,17 @@ tabbrowser {
> >   max-width: 0.1px;
> >   min-width: 0.1px;
> >   opacity: 0 !important;
> >   transition: min-width 200ms ease-out,
> >               max-width 250ms ease-out,
> >               opacity 50ms ease-out 180ms /* hide the tab for the last 20ms of the max-width transition */;
> > }
> > 
> >+.tab-icon-image:not([src]):not([pinned]),
> > .tab-throbber:not([fadein]):not([pinned]),
> > .tab-label:not([fadein]):not([pinned]),
> > .tab-icon-image:not([fadein]):not([pinned]),
> > .tab-close-button:not([fadein]):not([pinned]) {
> >   display: none;
> > }
> 
> These rules are about tab animations, which your selector has nothing to do
> with. You should add it here at line 44:
> http://hg.mozilla.org/mozilla-central/annotate/d8202613aaea/browser/base/
> content/tabbrowser.css#l44
> 

Good call - thanks. Fixed.

> >--- a/browser/themes/osx/browser.css	Fri Apr 12 18:33:01 2013 -0400
> >+++ b/browser/themes/osx/browser.css	Wed Apr 17 14:18:35 2013 -0400
> 
> >+.tab-text {
> >+  margin: 0;
> >+}
> 
> .tab-label
> 

Alright, switched. Although, for my own education, why the preference for .tab-label over .tab-text?

> >--- a/browser/themes/shared/tabs.inc.css	Fri Apr 12 18:33:01 2013 -0400
> >+++ b/browser/themes/shared/tabs.inc.css	Wed Apr 17 14:18:35 2013 -0400
> 
> >+.tab-throbber,
> >+.tab-icon-image {
> >+  width: 16px;
> >+  height: 16px;
> >+  list-style-image: url("chrome://mozapps/skin/places/defaultFavicon.png");
> >+}
> 
> defaultFavicon.png doesn't make sense for .tab-throbber. This is
> particularly confusing because you put this in tabs.inc.css while leaving
> the .tab-throbber specific rules in the individual browser.css files.

Fixed!
Comment 42 User image Dão Gottwald [:dao] 2013-04-24 11:12:30 PDT
(In reply to Mike Conley (:mconley) from comment #41)
> Alright, switched. Although, for my own education, why the preference for
> .tab-label over .tab-text?

.tab-label is tabbrowser specific, whereas .tab-text applies to all XUL tabs in the window.
Comment 43 User image Dão Gottwald [:dao] 2013-04-24 11:14:28 PDT
Comment on attachment 741433 [details] [diff] [review]
Patch v1.2 (ui-r+'d by shorlander)

You don't seem to be setting defaultFavicon.png anymore. It's still needed for pinned tabs.
Comment 44 User image Mike Conley (:mconley) 2013-04-24 11:17:35 PDT
Created attachment 741449 [details] [diff] [review]
Patch v1.3 (ui-r+'d by shorlander)

Ah, good call. Does this cover all of the bases?
Comment 45 User image Mike Conley (:mconley) 2013-04-24 13:07:42 PDT
Thanks Dão!

Landed on UX as https://hg.mozilla.org/projects/ux/rev/fd26cf8fc03a
Comment 46 User image Mike Conley (:mconley) 2013-04-24 14:16:52 PDT
Landed on Jamun as https://hg.mozilla.org/projects/jamun/rev/8bf747097b31
Comment 47 User image Siddhartha Dugar [:sdrocking] 2013-04-25 11:30:53 PDT
Will this land on Nightly before Australis lands (like the separate bookmarks button did)?
Comment 48 User image Mike Conley (:mconley) 2013-04-25 15:25:45 PDT
(In reply to Siddhartha Dugar [:sdrocking] from comment #47)
> Will this land on Nightly before Australis lands (like the separate
> bookmarks button did)?

Hey Siddhartha,

This will land when Australis lands.

-Mike
Comment 49 User image rexyrexy2 2013-05-03 11:02:29 PDT
there should at least be an about:config entry on whether to show the placeholder or not. for if some people want to get it without user script hacks
Comment 51 User image LafinJack 2013-12-02 14:56:00 PST
(In reply to rexyrexy2 from comment #49)
> there should at least be an about:config entry on whether to show the
> placeholder or not. for if some people want to get it without user script
> hacks

Agreed. When using vertical tabs the text of non-favicon tabs doesn't line up with other tabs.
Comment 52 User image Omar 2016-01-05 18:32:04 PST
Why is this bug marked "fixed"? The problem still exists in the latest versions of Firefox
Comment 53 User image Mike Conley (:mconley) 2016-01-07 07:27:45 PST
(In reply to Omar from comment #52)
> Why is this bug marked "fixed"? The problem still exists in the latest
> versions of Firefox

Can you please post a screenshot of the icon you're seeing?f

Note You need to log in before you can comment on or make changes to this bug.